ALTER PROC [dbo].[usp_CreateAuditHashSchemaAndData] (@FileName NVARCHAR(200), @ReturnMsg int OUT)
WITH EXECUTE AS OWNER
AS
BEGIN

--DECLARE @FileName NVARCHAR(200) = '200TestFile.txt';

DECLARE @SQLFileName NVARCHAR(200) = '[dbo].[stg_' + @FileName +']';

DECLARE @InsertStatement NVARCHAR(3800) = 'INSERT INTO [AuditH2].[AuditHashTable] ([TableName], [FileCreatedAndModified], [H2RNr], ' +
										  ' [H2DataDate],[CheckSumOriginal], [CheckSumCurrent], [CheckSumCalcDate] ) ' +
										  'select ''' + @SQLFileName + 
                                          ''' [TableName], [FileCreatedAndModified], [H2RNr], [H2DataDate], CHECKSUM(*) [CheckSumOriginal], ' +
										  ' CHECKSUM(*) [CheckSumCurrent], GETDATE() FROM ' +
										  @SQLFileName;
SELECT @InsertStatement; 

IF  NOT EXISTS (SELECT * FROM sys.database_principals WHERE name = N'AuditH2')
    CREATE USER [AuditH2] WITHOUT LOGIN WITH DEFAULT_SCHEMA=[dbo];



IF NOT EXISTS (SELECT 1 FROM sys.schemas WHERE name = 'AuditH2')
   --CREATE SCHEMA AuditH2;
   Print 'Need to Create the AuditH2 Schema';

IF (NOT EXISTS (SELECT * 
                 FROM INFORMATION_SCHEMA.TABLES 
                 WHERE TABLE_SCHEMA = 'AuditH2' 
                 AND  TABLE_NAME = 'AuditHashTable'))

	CREATE TABLE [AuditH2].[AuditHashTable](
		[TableName] [nvarchar](1024) NULL,
		[FileCreatedAndModified] [nvarchar](100) NULL,
		[H2RNr] [bigint] NULL,
		[H2DataDate] [datetime] NULL,
		[CheckSumOriginal] [bigint] NULL,
		[CheckSumCurrent] [bigint] NULL,
		[CheckSumCalcDate] [datetime] NULL) ON [PRIMARY] ; 

 
 EXEC sp_executesql @InsertStatement

 SET @ReturnMsg = (SELECT @@ERROR);

 END